--- a/cmake/check_compiler_flag.cmake
+++ b/cmake/check_compiler_flag.cmake
@@ -18,7 +18,7 @@ SET(ENV{LANG} C)
 MACRO (MY_CHECK_C_COMPILER_FLAG flag)
   STRING(REGEX REPLACE "[-,= +]" "_" result "have_C_${flag}")
   SET(SAVE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
-  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${flag}")
+  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${flag} -Werror")
   CHECK_C_SOURCE_COMPILES("int main(void) { return 0; }" ${result}
     ${fail_patterns})
   SET(CMAKE_REQUIRED_FLAGS "${SAVE_CMAKE_REQUIRED_FLAGS}")
@@ -27,7 +27,7 @@ ENDMACRO()
 MACRO (MY_CHECK_CXX_COMPILER_FLAG flag)
   STRING(REGEX REPLACE "[-,= +]" "_" result "have_CXX_${flag}")
   SET(SAVE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
-  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${flag}")
+  SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} ${flag} -Werror")
   CHECK_CXX_SOURCE_COMPILES("int main(void) { return 0; }" ${result}
     ${fail_patterns})
   SET(CMAKE_REQUIRED_FLAGS "${SAVE_CMAKE_REQUIRED_FLAGS}")
--- a/libmariadb/plugins/auth/CMakeLists.txt
+++ b/libmariadb/plugins/auth/CMakeLists.txt
@@ -99,7 +99,7 @@ IF(NOT WIN32)
   INCLUDE(${CC_SOURCE_DIR}/cmake/FindGSSAPI.cmake)
   IF(GSSAPI_FOUND)
     SET(GSSAPI_SOURCES ${AUTH_DIR}/auth_gssapi_client.c ${AUTH_DIR}/gssapi_client.c ${AUTH_DIR}/gssapi_errmsg.c)
-    CHECK_C_COMPILER_FLAG(-Wl,--as-needed have_C__Wl___as_needed)
+    MY_CHECK_C_COMPILER_FLAG(-Wl,--as-needed)
   ENDIF()
 ELSE()
   SET(GSSAPI_LIBS secur32)
